<?php

namespace FiloBlu\Newsletter\Setup;

use Magento\Eav\Setup\EavSetupFactory;
use Magento\Framework\Setup\UpgradeDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Eav\Model\Config;

class UpgradeData implements UpgradeDataInterface {

    private $eavSetupFactory;

    public function __construct(EavSetupFactory $eavSetupFactory, Config $eavConfig) {
        $this->eavSetupFactory = $eavSetupFactory;
        $this->eavConfig = $eavConfig;
    }

    public function upgrade(ModuleDataSetupInterface $setup, ModuleContextInterface $context) {
        if (version_compare($context->getVersion(), '1.0.5') < 0) {
            $eavSetup = $this->eavSetupFactory->create(['setup' => $setup]);
            $eavSetup->addAttribute(
                    \Magento\Customer\Model\Customer::ENTITY, 'country_id', [
                'type' => 'varchar',
                'label' => 'Country',
                'input' => 'select',
                'source' => 'Magento\Customer\Model\ResourceModel\Address\Attribute\Source\Country',
                'required' => true,
                'sort_order' => 100,
                'system' => false,
                'position' => 100
                    ]
            );
            $sampleAttribute = $this->eavConfig->getAttribute(\Magento\Customer\Model\Customer::ENTITY, 'country_id');
            $sampleAttribute->setData(
                    'used_in_forms', ['adminhtml_customer', 'checkout_register', 'customer_account_create', 'customer_account_edit', 'adminhtml_checkout']
            );
            $sampleAttribute->save();
        }
        if (version_compare($context->getVersion(), '1.0.16') < 0) {

            $setup->startSetup();

            $eavSetup = $this->eavSetupFactory->create();

            $entityTypeId = \Magento\Customer\Model\Customer::ENTITY;
            $eavSetup->removeAttribute($entityTypeId, 'country_id');

            $setup->endSetup();
        }
    }

}
